PROGRAM Equip;
{  This program performs Bios interrupt hex 11 the equipment check.
{  Upon return, the bits of AX contain the needed information.
{  AX is passed to the DecBin procedure which converts the integer
{  into a character array that contains the binary form of AX.
{  The equipment attached to the PC can be determined from the binary
{  form.
{  Danny Cavasos         June 1984  }
TYPE
  RecPack = RECORD
    AX,BX,CX,DX,BP,SI,DI,DS,ES,FLAGS: INTEGER;
  END;
  Btype=ARRAY[1..17] OF CHAR;
VAR
  IntParm         :RecPack;
  Binary          :Btype;
  i,Decimal       :INTEGER;
{$i decbin.pas}
BEGIN
  WITH IntParm DO
    BEGIN
      INTR($11,IntParm);
      Decimal:=AX;
    END;
  WRITELN(Decimal);
  DecBin(Decimal,Binary);
  FOR i:=2 TO 17 DO WRITE(Binary[i]);
END.
