PROGRAM DIR;
{
           JUNE 28, 1984

           Author:       Todd Little
                         1318 Bullock
                         Houston, TX  77055
                         713-984-2055 h
                             578-3210 w

}

var
   es,bx :integer;
   al :byte;
   file_search : string[20];

procedure getdta;

{
   Get the current DTA (data transfer address)
   Use the DOS call 2f to put the DTA into ES:BX
   Then put these into the variables of the same name

}
begin
  inline
    ( $b4/$2f/          {mov ah,2f}
      $cd/$21/          {int,21}
      $89/$1e/bx/       {mov (bx),bx  }
      $8c/$c3/          {mov bx,es }
      $89/$1e/es        {mov (es),bx  }
        )
   end;



procedure getdir(var file_search);

{
    Get the directory by using the find first operation, dos call 4e
    get subsequent entries using dos call 4f

    file_search  should contain the matching parameters, i.e. *.*
}
var
   i,j : integer;
   file_name : string[20];


begin


   begin;
      inline  (
         $8b/$56/$04/    {mov dx,[bp+04]    point to file_search}
         $81/$c2/$01/$00/{add dx,0001       move past the string length}
         $b9/$00/$00/    {mov cx,0010       search for files (inc dir)}
         $b4/$4e/        {mov ah,4e         dos call 4e}
         $cd/$21/        {int 21h           }
         $a2/al          {mov (al),al       save the error code}
           )
      end;

   j := 0;
   writeln;

   while (al <> 02) and (al <> 18) do
   begin

      if j mod 5 = 0 then
         writeln;

      i := 30;
      file_name := '';

      while mem[es:bx+i] <> 0 do
      begin
        file_name := concat(file_name,chr(mem[es:bx+i]) );
        i := i +1;
      end;

      write(file_name:15);
      j := j +1;

      begin
      inline  (
         $b4/$4f/        {mov ah,4f         find next}
         $cd/$21/        {int 21h           with dos call 4f}
         $a2/al          {mov (al),al       save return code}
           )
      end;

  end;

end;

begin

   getdta;
   file_search := concat( '*.*',chr(0) );
   getdir(file_search);
   end.
